//+------------------------------------------------------------------+
//|                                              iK_ex_LinReg.mq4 |
//|                                                      Ivan Katsko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Ivan Katsko"
#property link      "ICQ:372739628"
//--------------------------------------------------------------- 1 --
#define NONE 0

extern string S1=".    ";
extern int Nlin=12;
extern string S2=".    ";
extern int r0=150;
extern string S3="   .  ";
extern double t0=2.618;
extern datetime StartDateTime = D'01.01.2010';  // 
extern datetime FinishDateTime = D'31.12.2010'; // 
extern double Lots   = 1;            //   .  ("0" -   )
extern double Prots  = 0.07;         //   
extern int SlipPage     = 3;         //   -  
 
bool 
     Msg=true,
     New_Bar=false,                  //    
     Cls=false,                      //   
     Work=true,                      //   .
     Opn_R=false;                    //     

string Symb;                         //  . 

static datetime New_Time;


double dirOpen       = NONE;           //   : ">0" - ; "<0" - 

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   Fun_New_Bar();                      //    
//----
   int
      Total,                           //     
      Tip=-1,                          //  .  (B=0,S=1)
      Ticket;                          //  
   double
      Lot,                             // .    
      Lts,                             // .    
      Min_Lot,                         //   
      Step,                            //    
      Free,                            //   
      One_Lot,                         //   
      SL,                              // SL   
      TP;                              // TP  
   bool
      Ans  =false,                     //    
      Opn_B=false,                     //     Buy
      Opn_S=false;                     //     Sell
      
   Cls  =false;                        //   
//   Time_Begin=GetTickCount();          //     
   
//-------------------      --
   if (New_Bar)                        //      
     {
//      Tag_msg1=true;
//      Opn_R=true;
      
      // .
      if(TimeCurrent()<StartDateTime)            //    
        { 
        Alert("   .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if (TimeCurrent()>=FinishDateTime)         //  
        { 
        Alert("  .   .",": ",Symb,", ",Period());
        return;                                  //   start()
        }            
      if(Work==false)                            //  
        {
         Alert(" .   .",": ",Symb,", ",Period());
         return;                                 //   start()
        }
     }
//-------------------       --

            
   if ((TimeCurrent()-Time[0]-50)>(Period()-1)*60 // 10    
//       && Tag_msg1
       ) 
     { 
//      Alert("!   !",": ",Symb,", ",Period());
//      Tag_msg1=false;
     }
   
//-----------------------  
   Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .",": ",Symb,", ",Period());
            return;                             //   start()
           }
         Ticket =OrderTicket();                 //  . .
         Tip    =OrderType();                   //   .
         SL     =OrderStopLoss();               // SL  .
         TP     =OrderTakeProfit();             // TP  .
         Lot    =OrderLots();                   //  
        }
     }
     
   if (New_Bar)                                  //    
     Msg=true;
//     {
      if (Total==0)                              //    
         Opn_R=true;                             //   
        else                                     //    
         Opn_R=false;                            //   (  )
//     }
      
   if (Total==0)                                 //    
     {
      Cls=false;                                 //   
      ObjectDelete("New_Open");                  //  
      ObjectDelete("New_SL"); 
     }

//----  
   if(Total==0)
     {
     SL = iCustom(0, 0, "Dserg-LinRegressionBreakout_v1.1","",Nlin,"",r0,"",t0,"",1,"",5000,2, 0);
     double Up = iCustom(0, 0, "Dserg-LinRegressionBreakout_v1.1","",Nlin,"",r0,"",t0,"",1,"",5000,5, 0);
     double Dn = iCustom(0, 0, "Dserg-LinRegressionBreakout_v1.1","",Nlin,"",r0,"",t0,"",1,"",5000,6, 0);
     TP = iCustom(0, 0, "Dserg-LinRegressionBreakout_v1.1","",Nlin,"",r0,"",t0,"",1,"",5000,7, 0);
     }

//----         
   if((Tip==0                                     //    
       && Ask>=TP)    
      ||                                          // 
       (Tip==1                                     //    
       && Bid<=TP))    
     {                                           
     Cls = true;                                 //   
     //Opn_R=false;                                //       
     }

//----   
   if(Total==0                                    //   ,
//     && AllowFindForw                            
     && Opn_R)                                   //       
     {
     if(Up>0)
       Opn_B=true;                               //     Buy
     if(Dn>0)
       Opn_S=true;                               //  Sell
     }

//--------------------------------------------------------------- 7 --
   //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   
 
   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  
 
   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   
   if (Lts*One_Lot > Free &&                    //   .
      TimeCurrent()<(Time[0] + 2*60) &&         //     2- 
      Total==0)                                 //    
     {
      Alert("     ", Lts," ",": ",Symb,", ",Period());
      return;                                   //   start()
     }

//--------------------------------------------------------------- 6 --
   //  
   while(Ticket>0)                              //   .
     {
      if(Tip==0 && Cls==true)                  //   Buy..
        {                                       //    
        Alert("  Buy: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Bid,2,Blue);      //  Buy
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
//            Opn_R=false;                        //       
          Opn_R=true;                        //   
          continue;                           //  
          }
        return;                                //   start()
        }
      if(Tip==1 && Cls==true)                  //   Sell..
        {                                       //    
        Alert("  Sell: ",Symb,", ",Period());
        RefreshRates();                        //  
        Ans=OrderClose(Ticket,Lot,Ask,2,Red);      //  Sell
        if(Ans==true)                         //  :)
          break;                              //    
        if(Fun_Error(GetLastError())==1)      //  
          {
//            Opn_R=false;                        //       
          Opn_R=true;                         //   
          continue;                           //  
          }
        return;                                //   start()
        }
      break;                                    //   while
     }
   
//----  
   while(Opn_R)                                 //   .
     {
      if(Total==0 && Opn_B==true)              //  .  +
        {                                       //  . Buy
        RefreshRates();                        //  
        Alert("  Buy: ",Symb,", ",Period());
        Ticket=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP,0,0,0,Blue);// Buy
        if(Ticket > 0)                        //  :)
          {
//          AllowEsc=true;
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      if(Total==0 && Opn_S==true)              //  .  +
        {                                       //  . Sell
        RefreshRates();                        //  
        Alert("  Sell: ",Symb,", ",Period());
        Ticket=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP,0,0,0,Red);// Sel
        if(Ticket > 0)                        //  :)
          {
//          AllowEsc=true;
          return;                             //   start()
          }
        if(Fun_Error(GetLastError())==1)      //  
          continue;                           //  
        return;                                //   start()
        }
      break;                                    //   while
     }   
//----
   return;                                      //   start()
  }
//-------------------------------------------------------------- 10 --
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case   4: Alert("  .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 128: Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 130:Alert("  ..",": ",Symb,", ",Period());
         Opn_R=false;                           //      
         return(1);                             //   
      case 135:Alert(" .   ..",": ",Symb,", ",Period());
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..",": ",Symb,", ",Period());
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..",": ",Symb,", ",Period());
         Sleep(3000);                           //  
         return(1);                             //   
      case 138:Alert("  ..",": ",Symb,", ",Period());
         return(1);                             //   
      case 145:Alert("     .   15.",": ",Symb,", ",Period());
         Cls = false;
         Sleep(15000);                        //  
         return(1);                             //   
      case 146:Alert("  .  ..",": ",Symb,", ",Period());
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case  5: Alert("  .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .",": ",Symb,", ",Period());
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .",": ",Symb,", ",Period());
         return(0);                             //   
      case 134:Alert("    .",": ",Symb,", ",Period());
         return(0);                             //   
      default: Alert("  ",Error,": ",Symb,", ",Period()); //     
         return(0);                             //   
     }
  }
//-------------------------------------------------------------- 11 --
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symbol(),MODE_STOPLEVEL)+MarketInfo(Symbol(), MODE_SPREAD)+SlipPage;// . 
   if (Parametr < Min_Dist)                     //   .
     {
      Parametr=Min_Dist;                        //  .
     }
   return(Parametr);                            //  
  }
//+------------------------------------------------------------------+
void Fun_New_Bar()                              // -   
  {                                             
   New_Bar=false;                               //   
   if(New_Time!=Time[0])                        //  
     {
      New_Time=Time[0];                         //   
      New_Bar=true;                             //     
     }
  }
//-------------------------------------------------------------- 12 --
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   New_Time=Time[0];                               //   
      //    
   bool Msg=true;
   int 
      Total,                                       //     
      Ticket,
      Tip=-1;                                      //  .  (B=0,S=1)
   double 
      TP,
      SL;

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symbol())continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         SL     =OrderStopLoss();                  // SL  .
         TP     =OrderTakeProfit();                // TP  .
        }
     }
            //      
      ObjectDelete("New_Open"); 
      ObjectDelete("New_SL"); 
     }                                                      //   

  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
      //    
   int 
      Total,                                       //     
      Tip=-1,                                      //  .  (B=0,S=1)
      Ticket;
   double 
      TP,
      SL;

   for(int i=1; i<=OrdersTotal(); i++)             //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true)    //   
        {                                          //  :
         if (OrderSymbol()!=Symbol())continue;         //   . 
         if (OrderType()>1)                        //  
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Total++;                                  //  . 
         if (Total>1)                              //    
           {
            Alert("  .   .",": ",Symbol(),", ",Period());
            return;                                //   start()
           }
         Ticket =OrderTicket();                    //  . .
         Tip    =OrderType();                      //   .
         SL     =OrderStopLoss();                  // SL  .
        }
     }
   ObjectDelete("New_Open"); 
   ObjectDelete("New_SL"); 
   return(0);
  }


